#ifndef TESTGAME_H
#define TESTGAME_H

#include "Tools.h"
#include "GameControlBase.h"


//----------------------------------------------------------------------------
/**
 * Special implementation of GameControlBase for the test suite.
 */
class TestGame : public GameControlBase
{
    //------------------------------------------------------------------------
    class TestGameState;
    friend class TestGameState;
    class TestGameState : public GameStateBase
    {
        STATE_OBJECT(TestGameState);
      public:
        TestGameState() {}
        ~TestGameState() {}

        void updateShipControl(ShipControl control, GameControlBase *game) {}
    };

  public:
    TestGame();
    ~TestGame();

    //------------------------------------------------------------------------
    void initGameControl(const XMLNode *gameControlNode)
        throw (Exception);

  private:

    GameStateBase *getRunningState() const
    {
        return TestGameState::getInstance();
    }

    bool continueAfterExplosion() const { return true; }
};

#endif //TESTGAME_H
